<?php
/***********************************************************
*
* ssLinks v1.1 - a PHP / mySQL links management system
* (c) Simon Willison 2001
* For more information, visit www.tfc-central.co.uk/sslinks/
*
***********************************************************/

/***********************************************************
*
* Change log for v1.1 (improvements since 1.0)
*
* i.   Fixed 'FLF Central' bug where some error messages and the login screen
*      contained a reference to 'FLF Central' - they now show the site name as
*      defined by the $sitename variable. :o)
* ii.  Added 'Top Rated Links', 'Most Popular Links' and 'New Links' pages.
* iii. Made it possible to edit categories (omission from ssLinks v1.0).
* iv.  Added number of links in this category - appears next to the category name.
* v.   Added alternative header / footer functions allowing proper PHP includes.
*
***********************************************************/


// mySQL database Host / Name / Username / Password

$db_host = "localhost"; // Your mySQL server host address
$db_name = "databasename"; // The name of the database to use
$db_user = "username"; // Your mySQL username
$db_pass = "password"; // Your mySQL password

// Admin username / password for the script

$admin_user = "Admin"; // This is the username used to log in as an admin
$admin_pass = "sslinks"; // This is the password used to log in as an admin

// Files containing header and footer HTML, also name of the site

$sitename = "ssLinks Demo"; 		// Set this to the name of your site
$sitemail = "you@yourdomain.com"; 	// Set to your e-mail address.
					// mails sent automatically by the links script
					// will be 'from' this address.

// Preferences:

$showdate = "yes"; // set to "no" if you do not want the date links were added displayed
$minvotes = "10"; // Minimum number of votes needed before link displayed on "top rated" page
$nol = "20"; // Number Of Links to show on what's new / top rated / most popular

$header_file = "header.html"; // Set this to the path to your header template file
$footer_file = "footer.html"; // Set this to the path to your footer template file
$template_php = "no"; // Set this to yes if you wish to use PHP code in your template files
		      // if set to 'yes' template support will be turned off - i.e %title%
		      // will not be replaced by the title of the page.

// NB - any occurences of %title% in the header file will be replaced by the page title

// You should not need to change anything beneath this line.

function html_header($title)
{ 
	// open header file - replace %title% in the file with whatever title is
	global $header_file, $template_php;
	if ($template_php != "yes")
	{	$file = fopen($header_file, "r");
		$contents = fread($file, filesize($header_file));
		fclose($file);
		$header = eregi_replace('%title%', $title, $contents);
		return $header;
	}
	else
	{
		include($header_file);
		return "";
	}
}

function html_footer()
{
	global $admin, $footer_file, $template_php;
	// First build standard footer for all links pages - then load template
	$footer =  "<span class=small><a href=\"links.php\">Links Home</a> | <a href=\"links.php?action=search\">Search Links</a> | <a href=\"links.php?action=newlinks\">New Links</a> | <a href=\"links.php?action=popular\">Popular Links</a> | <a href=\"links.php?action=rated\">Top Rated</a> | ";
	if (!$admin)
	{
		$footer .= "<a href=\"links.php?action=loginform\">Admin Login</a>";
	}
	else
	{
		$footer .= "<a href=\"links.php?action=validate\">Validate Links</a>";
	}
	$footer .= " | Powered by <a href=\"http://www.tfc-central.co.uk/sslinks/\" target=\"_blank\">ssLinks</a> v1.1</span>";
	if ($template_php != "yes")
	{
		// Now load template and add it to the HTML already generated.
		$file = fopen($footer_file, "r");
		$contents = fread($file, filesize($footer_file));
		fclose($file);
		$footer .= $contents;
		return $footer;
	}
	else
	{
		echo $footer;
		include($footer_file);
		return "";
	}	
}

function cats_table($id)
{
	global $db_host, $db_name, $db_user, $db_pass, $admin, $numlinks;
	
	// Returns HTML for a table showing all categories attached to $num
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database in cats_table().");
	$result = mysql_query("SELECT lcat_id, lcat_name, lcat_ranking FROM sslinkcats WHERE lcat_cat = '$id' ORDER BY lcat_ranking DESC, lcat_name");
	if (!$result)
		die("SQL result to get cats failed");
	$num = mysql_num_rows($result);
	if ($num == 0)
		return "";
	$html = "<b>Categories:</b><br>\n<table border=0 cellspacing=2 cellpadding=2 width=80%>\n";
	$i = 1;
	while ($row = mysql_fetch_array($result))
	{
		$catid = $row["lcat_id"];
		$catname = $row["lcat_name"];
		$rank = $row["lcat_ranking"];
		$lcat_numlinks = $numlinks[$catid];
		if (!$lcat_numlinks)
			$lcat_numlinks = 0;
		$html .= "<td class=\"standard\" width=50%>&middot; <a href=\"links.php?cat=$catid\">$catname</a> ($lcat_numlinks)";
		if ($admin)
			$html .= " Rank: $rank | <a href=\"links.php?action=editcat&id=$catid\">Edit Category</a>";
		$html .= "</td>";
		if (is_int($i / 2))
			$html .= "<tr>\n";
		$i++;
	}
	$html .= "</table><p>\n";
	return $html;
}

function cats_sql($sql)
{
	global $db_host, $db_name, $db_user, $db_pass, $admin, $numlinks;
	
	// Returns HTML for a table showing all categories found using search term

	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$result = mysql_query($sql);
	if (!$result)
		die("SQL result failed");
	$num = mysql_num_rows($result);
	if ($num == 0)
		return "";
	$html = "<b>Categories:</b><br>\n<table border=0 cellspacing=2 cellpadding=2 width=80%>\n";
	$i = 1;
	while ($row = mysql_fetch_array($result))
	{
		$catid = $row["lcat_id"];
		$catname = $row["lcat_name"];
		$rank = $row["lcat_ranking"];
		$lcat_numlinks = $numlinks[$catid];
		if (!$lcat_numlinks)
			$lcat_numlinks = 0;
		$html .= "<td class=\"standard\" width=50%>&middot; <a href=\"links.php?cat=$catid\">$catname</a> ($lcat_numlinks)";
		if ($admin)
			$html .= " Rank: $rank";
		$html .= "</td>";
		if (is_int($i / 2))
			$html .= "<tr>\n";
		$i++;
	}
	$html .= "</table><p>\n";
	return $html;
}

function get_catheader($id)
{
	global $db_host, $db_name, $db_user, $db_pass;
	// returns the description field lcat_header of the specified category
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$result = mysql_query("SELECT lcat_header FROM sslinkcats WHERE lcat_id = '$id'");
	if (!$result)
		die("SQL result failed to get cat_header");
	while ($row = mysql_fetch_array($result))
	{
		$header = $row["lcat_header"];
	}
	$return = "";
	if ($header != "")
		$return = "$header<p>\n";
	return $return;		
}

function get_catname($id)
{
	global $db_host, $db_name, $db_user, $db_pass;
	// returns the name of the specified category
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$result = mysql_query("SELECT lcat_name FROM sslinkcats WHERE lcat_id = '$id'");
	if (!$result)
		die("SQL result failed to get cat name");
	while ($row = mysql_fetch_array($result))
	{
		$name = $row["lcat_name"];
	}
	if ($name == "")
		$name = "Links Home Page";
	return $name;		
}

function show_links($id)
{
	global $db_host, $db_name, $db_user, $db_pass, $admin, $showdate;
	
	// Returns HTML for displaying list of links attached to category where id = $id
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database in show_links().");
	$result1 = mysql_query("SELECT * FROM sslinks WHERE link_cat = '$id' AND link_validated = 'yes' AND link_recommended = 'yes' ORDER BY link_name");
	if (!$result1)
		die("SQL result failed to get links: $result1");
	$num1 = mysql_num_rows($result1);
	$result2 = mysql_query("SELECT * FROM sslinks WHERE link_cat = '$id' AND link_validated = 'yes' AND link_recommended = 'no' ORDER BY link_name");
	if (!$result2)
		die("SQL result failed");
	$num2 = mysql_num_rows($result2);
	if (($num1 == 0) && ($num2 == 0))
		return false;
	$html = "";
	while ($row = mysql_fetch_array($result1))
	{
		$lid = $row["link_id"];
		$name = $row["link_name"];
		$hits = $row["link_hits"];
		$desc = $row["link_desc"];
		$url = $row["link_url"];
		$totalrate = $row["link_totalrate"];
		$numvotes = $row["link_numvotes"];
		$dateadd = $row["link_dateadd"];
		$dateadd = date ("jS M Y", $dateadd);
		if ($numvotes > 0)
		{
			$avgrate = sprintf ("%.2f", ($totalrate / $numvotes));
		}
		else
		{
			$avgrate = 0;
		}
		$rateme = "<input type=hidden name=action value=rate><input type=hidden name=id value=$lid>";
		$rateme .= "<select name=score size=1 class=small onchange=\"document.rate$lid.submit()\">";
		$rateme .= "<option>-";
		$rateme .= "<option>1";
		$rateme .= "<option>2";
		$rateme .= "<option>3";
		$rateme .= "<option>4";
		$rateme .= "<option>5";
		$rateme .= "<option>6";
		$rateme .= "<option>7";
		$rateme .= "<option>8";
		$rateme .= "<option>9";
		$rateme .= "<option>10";
		$rateme .= "</select>";
		$html .= "<form action=links.php method=post name=rate$lid><td class=standard><font color=#ff0000><small>REC</small></font> <a href=\"links.php?go=$lid\" target=\"_blank\" onmouseout=\"window.status=' '; return true\" onmouseover=\"window.status='$url'; return true\">$name</a> <span class=small>[$hits hits, $numvotes votes, Average Rating $avgrate]";
		if ($showdate == "yes")
			$html .= " [Added: $dateadd]";
		$html .= "</span>";
		if ($admin)
			$html .= " - <a href=\"links.php?action=editlink&id=$lid\">Edit Link</a> | <a href=\"links.php?action=dellink&id=$lid\">Delete Link</a>";
		$html .= "<br>\n$desc <span class=small>RATE THIS: </span>$rateme</td></form><tr>\n";
	}
	if (strlen($html) > 1)
	{
		$html .= "<td>&nbsp;</td><tr>\n";
	}
	$row[] = "";
	while ($row = mysql_fetch_array($result2))
	{
		$lid = $row["link_id"];
		$name = $row["link_name"];
		$hits = $row["link_hits"];
		$url = $row["link_url"];
		$desc = $row["link_desc"];
		$totalrate = $row["link_totalrate"];
		$numvotes = $row["link_numvotes"];
		$dateadd = $row["link_dateadd"];
		$dateadd = date ("jS M Y", $dateadd);
		
		if ($numvotes > 0)
		{
			$avgrate = sprintf ("%.2f", ($totalrate / $numvotes));
		}
		else
		{
			$avgrate = 0;
		}
		$rateme = "<input type=hidden name=action value=rate><input type=hidden name=id value=$lid>";
		$rateme .= "<select name=score size=1 class=small onchange=\"document.rate$lid.submit()\">";
		$rateme .= "<option>-";
		$rateme .= "<option>1";
		$rateme .= "<option>2";
		$rateme .= "<option>3";
		$rateme .= "<option>4";
		$rateme .= "<option>5";
		$rateme .= "<option>6";
		$rateme .= "<option>7";
		$rateme .= "<option>8";
		$rateme .= "<option>9";
		$rateme .= "<option>10";
		$rateme .= "</select>";
		$html .= "<form action=links.php method=post name=rate$lid><td class=standard><a href=\"links.php?go=$lid\" target=\"_blank\" onmouseout=\"window.status=' '; return true\" onmouseover=\"window.status='$url'; return true\">$name</a> <span class=small>[$hits hits, $numvotes votes, Average Rating $avgrate]";
		if ($showdate == "yes")
			$html .= " [Added: $dateadd]";
		$html .= "</span>";
		if ($admin)
			$html .= " - <a href=\"links.php?action=editlink&id=$lid\">Edit Link</a> | <a href=\"links.php?action=dellink&id=$lid\">Delete Link</a>";
		$html .= "<br>\n$desc <span class=small>RATE THIS: </span>$rateme</td></form><tr>\n";
	}
	$html = "<b>Links:</b><p>\n<table border=0 cellpadding=1 cellspacing=1 width=100%>\n" . $html;
	$html .= "</table><p>\n";
	return $html;
}

function links_sql($sql)
{
	global $db_host, $db_name, $db_user, $db_pass, $admin, $showdate;
	
	// Returns HTML for displaying list of links found using supplied SQL query
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$result = mysql_query($sql);
	if (!$result)
		die("SQL result failed");
	$num = mysql_num_rows($result);
	if ($num == 0)
		return false;
	$html = "";
	while ($row = mysql_fetch_array($result))
	{
		$lid = $row["link_id"];
		$name = $row["link_name"];
		$hits = $row["link_hits"];
		$url = $row["link_url"];
		$desc = $row["link_desc"];
		$totalrate = $row["link_totalrate"];
		$numvotes = $row["link_numvotes"];
		$dateadd = $row["link_dateadd"];
		$dateadd = date ("jS M Y", $dateadd);
		if ($numvotes > 0)
		{
			$avgrate = sprintf ("%.2f", ($totalrate / $numvotes));
		}
		else
		{
			$avgrate = 0;
		}
		$rateme = "<input type=hidden name=action value=rate><input type=hidden name=id value=$lid>";
		$rateme .= "<select name=score size=1 class=small onchange=\"document.rate$lid.submit()\">";
		$rateme .= "<option>-";
		$rateme .= "<option>1";
		$rateme .= "<option>2";
		$rateme .= "<option>3";
		$rateme .= "<option>4";
		$rateme .= "<option>5";
		$rateme .= "<option>6";
		$rateme .= "<option>7";
		$rateme .= "<option>8";
		$rateme .= "<option>9";
		$rateme .= "<option>10";
		$rateme .= "</select>";
		$html .= "<form action=links.php method=post name=rate$lid><td class=standard><a href=\"links.php?go=$lid\" target=\"_blank\" onmouseout=\"window.status=' '; return true\" onmouseover=\"window.status='$url'; return true\">$name</a> <span class=small>[$hits hits, $numvotes votes, Average Rating $avgrate]";
		if ($showdate == "yes")
			$html .= " [Added: $dateadd]";
		$html .= "</span>";
		if ($admin)
			$html .= " - <a href=\"links.php?action=editlink&id=$lid\">Edit Link</a> | <a href=\"links.php?action=dellink&id=$lid\">Delete Link</a>";
		$html .= "<br>\n$desc <span class=small>RATE THIS: </span>$rateme</td></form><tr>\n";
	}
	$html = "<b>Links:</b><p>\n<table border=0 cellpadding=1 cellspacing=1 width=100%>\n" . $html;
	$html .= "</table><p>\n";
	return $html;
}

function jump_to($id)
{
	// redirect user to URL of $id and increment the hit counter
	global $db_host, $db_name, $db_user, $db_pass;
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$result = mysql_query("SELECT link_url, link_hits FROM sslinks WHERE link_id = '$id'");
	if (!$result)
		die("SQL result failed");
	$num = mysql_num_rows($result);
	if ($num == 0)
	{
		header("Location: links.php");
		exit;
	}
	while ($row = mysql_fetch_array($result))
	{
		$hits = $row["link_hits"];
		$url = $row["link_url"];
	}
	$hits++;
	$result2 = @mysql_query("UPDATE sslinks SET link_hits = '$hits' WHERE link_id = '$id'");
	header("Location: $url");
	exit;
}

function is_admin()
{
	global $Links_Cookie_User, $Links_Cookie_Pass, $admin_user, $admin_pass;
	if (($Links_Cookie_User == $admin_user) && ($Links_Cookie_Pass == $admin_pass))
		return true;
	return false;
}

function login($username, $password)
{
	setcookie("Links_Cookie_User", $username, time() + 3600);
	setcookie("Links_Cookie_Pass", $password, time() + 3600);
	header("Location: links.php");
	exit;
}

function logout()
{
	setcookie("Links_Cookie_User", "");
	setcookie("Links_Cookie_Pass", "");
	header("Location: links.php");
	exit;
}

function admin_options($cat)
{
	// display admin options for category
	global $linkshtml;
	$html = "<b>You are logged in as an admin</b> - <a href=\"links.php?action=logout\">Click here to log out</a>\n";
	if ((cats_table($cat) == "") && (!$linkshtml))
		echo "<a href=\"links.php?action=delcat&id=$cat\">Delete This Category</a> - ";
	$html .= "<hr>
<table width=100% border=0><td valign=top class=\"standard\" width=50%><b>Add a Category</b><form action=links.php method=post>
<input type=hidden name=action value=addcat>
<input type=hidden name=lcat_cat value=\"$cat\">
Category Name: <input type=text name=lcat_name size=30 maxlength=100><p>
Category Header:<br>
<textarea name=lcat_header cols=40 rows=4></textarea><p>
Category Ranking (optional): <input type=text name=lcat_ranking size=5 maxlength=11> *<p>
<div align=center><input type=submit name=submit value=\"Add Category\"></div><p>
<div class=small>* Rankings can be used to force certain categories to be listed first - categories of the same rank will be displayed in alphabetical order.</div></td></form><td valign=top class=\"standard\">
<b>Add a Link</b><p>
<form action=links.php method=post>
<input type=hidden name=action value=addlink>
<input type=hidden name=link_cat value=\"$cat\">
Link Name: <input type=text name=link_name size=30 maxlength=100><p>
Link URL: <input type=text name=link_url size=30 maxlength=255 value=\"http://\"><p>
Link Description:<br>
<textarea name=link_desc cols=40 rows=4></textarea><p>
Recommended? <select name=link_recommended size=1>\n<option selected>no\n<option>yes\n</select><p>
<div align=center><input type=submit name=submit value=\"Add Link\"></div>
</td></form><tr></table>";
	return $html;
}

function do_rating($id, $score)
{
	global $db_host, $db_name, $db_user, $db_pass;
	$cookie = "cookie_rate" . $id;
	global $$cookie;
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$result = mysql_query("SELECT link_totalrate, link_numvotes, link_cat FROM sslinks WHERE link_id = '$id'");
	if (!$result)
		die("SQL result failed");
	$num = mysql_num_rows($result);
	if ($num == 0)
	{
		header("Location: links.php");
		exit;
	}
	while ($row = mysql_fetch_array($result))
	{
		$numvotes = $row["link_numvotes"];
		$totalrate = $row["link_totalrate"];
		$cat = $row["link_cat"];
	}
	if ($$cookie == "yes")
	{
		header("Location: links.php?cat=$cat");
		exit;
	}
	$numvotes++;
	$totalrate = $totalrate + $score;
	$result2 = @mysql_query("UPDATE sslinks SET link_numvotes = '$numvotes', link_totalrate = '$totalrate' WHERE link_id = '$id'");
	setcookie($cookie, "yes", time() + 360000);
	header("Location: links.php?cat=$cat");
	exit;	
}

function add_link($link_name, $link_url, $link_desc, $link_cat, $link_recommended)
{
	// adds a link to the database
	global $db_host, $db_name, $db_user, $db_pass, $admin, $sitename;
	if ((!$link_name) || (!$link_url) || (!$link_desc) || (!isset($link_cat)))
	{
		echo html_header("$sitename - Error");
		echo "<b><a href=\"links.php\">Links Home</a> : Add Link Error</b><p>\n";
		echo "You did not fill in all of the required fields.  Hit 'back' and try again.<p>\n";
		echo html_footer();
		exit;
	}
	if (!$admin)
	{
		header("Location: links.php?action=logout");
		exit;
	}
	if (!$link_recommended)
		$link_recommended = "no";
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$time = time();
	$sql = "INSERT INTO sslinks SET
		link_name = '$link_name',
		link_cat = '$link_cat',
		link_url = '$link_url',
		link_desc = '$link_desc',
		link_numvotes = '0',
		link_dateadd = '$time',
		link_totalrate = '0',
		link_validated = 'yes',
		link_recommended = '$link_recommended'";
	$result = mysql_query($sql);
	if (!$result)
	{
		die("SQL result failed - link was not added");
	}
	else
	{
		header("Location: links.php?cat=$link_cat");
		exit;
	}	
}

function add_cat($lcat_name, $lcat_header, $lcat_cat, $lcat_ranking)
{
	// adds a link to the database
	global $db_host, $db_name, $db_user, $db_pass, $admin, $sitename;
	if ((!$lcat_name) || (!isset($lcat_cat)))
	{
		echo html_header("$sitename - Error");
		echo "<b><a href=\"links.php\">Links Home</a> : Add Category Error</b><p>\n";
		echo "You did not fill in all of the required fields.  Hit 'back' and try again.<p>\n";
		echo html_footer();
		exit;
	}
	if (!$admin)
	{
		header("Location: links.php?action=logout");
		exit;
	}
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$sql = "INSERT INTO sslinkcats SET
		lcat_name = '$lcat_name',
		lcat_cat = '$lcat_cat',
		lcat_header = '$lcat_header',
		lcat_ranking = '$lcat_ranking'";
	$result = mysql_query($sql);
	if (!$result)
	{
		die("SQL result failed - category was not added");
	}
	else
	{
		header("Location: links.php?cat=$lcat_cat");
		exit;
	}	
}

function do_breadcrumbs($cat)
{
	/* returns HTML for the breadcrumbs for the specified category
	
	Logic:  First round ($lcat != 0), get the name and id of the current category i.e the one being displayed.  The name will be displayed without a link at the end of the breadcrumbs.  Stick the HTML for this in the temporary HTML building variable.

	Second round, get the name and id of the next category up and add it (formatted) to the front of the HTML buliding variable.

	Repeat this step until $lcat = 0.  At this point bung on the link to the Links home page.

	I'm doing it a nasty way, with a loop that performs a database query each cycle */
	
	if ($cat == 0)
	{
		// This is the first page so no breadcrumbs needed
		return "<b>Links Home</b><p>";
	}
	global $db_host, $db_name, $db_user, $db_pass;
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	// Now loop through building up array $breadcrumbs until root (ie cat 0) is reached
	$lcat = $cat;
	$breadcrumbs = "";
	while ($lcat != 0)
	{
		$sql = "SELECT lcat_cat, lcat_name, lcat_id FROM sslinkcats WHERE lcat_id = '$lcat'";
		$result = mysql_query($sql);
		if (!$result)
		{
			die("SQL result failed - can't build breadcrumbs.");
		}
		while ($row = mysql_fetch_array($result))
		{
			$id = $row["lcat_id"];
			$lcat = $row["lcat_cat"];
			$name = $row["lcat_name"];
		}
		// defence against infinite loops
		if (!$id)
		{
			header("Location: links.php");
			exit;
		}
		if ($id == $cat)
		{
			// First round, so add just the name of the category and not the link
			$breadcrumbs = " : $name</b><p>";
			continue; // Start the next loop straight away
		}
		$breadcrumbs = " : <a href=\"links.php?cat=$id\">$name</a>" . $breadcrumbs;
	} // end while
	$breadcrumbs = "<b><a href=\"links.php?cat=0\">Links Home</a>" . $breadcrumbs;
	return $breadcrumbs;
}

function del_cat($id)
{
	// Requests confirmation then deletes the current category
	
	global $admin, $submit, $db_host, $db_name, $db_user, $db_pass;
	if (!$admin)
	{
		header("Location: links.php?action=logout");
		exit;
	}
	if ((cats_table($cat) == "") && (show_links($cat)))
	{
		// This category still has links / categories below it.  Do not allow it to be deleted.
		echo html_header("Error");
		echo "<b><a href=\"links.php\">Links Home</a> : Delete Category Error</b><p>\n";
		echo "There are still links and/or categories attached to this page.  You may not delete a page unless it is completely empty.<p>\n";
		echo html_footer();
		exit;
	}
	if (!$submit)
	{
		// display page requesting confirmation
		echo html_header("Confirm Deletion");
		echo "<b><a href=\"links.php\">Links Home</a> : Confirm Delete Category</b><p>\n";
		echo "Are you sure you would like to delete category $id?<p>\n";
		echo "<form action=links.php method=post>\n<input type=hidden name=id value=$id>\n";
		echo "<input type=hidden name=action value=delcat>\n<input type=submit name=submit value=\"Delete Category\"><p>\n";
		echo html_footer();
		exit;
	}
	// submit has been clicked - delete the category
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$sql = "DELETE FROM sslinkcats WHERE lcat_id = '$id'";
	$result = mysql_query($sql);
	if (!$result)
	{
		die("Unable to delete category from database");
	}
	else
	{
		// display page requesting confirmation
		echo html_header("Category Deleted");
		echo "<b><a href=\"links.php\">Links Home</a> : Category Deleted</b><p>\n";
		echo "Category $id has been deleted.<p><a href=\"links.php?cat=0\">Back to front page</a><p>\n";
		echo html_footer();
		exit;
	}
}

function rec_link($cat)
{
	// Allows any visitor to recommend a link for addition to the database - the link will be added
	// but the field link_validated will be set to 'no'
	
	global $db_host, $db_name, $db_user, $db_pass, $link_name, $link_desc, $link_url, $link_addname, $link_addemail, $submit, $sitename;
	
	if (!ereg("^[0-9]+$", $cat))
	{
		// function has been fed an invalid category id
		header("Location: links.php");
		exit;
	}
	if (!$submit)
	{
		// display form for adding new link
		$linkcat = get_catname($cat);
		echo html_header("Recommend a Link - $linkcat");
		echo "<b><a href=\"links.php\">Links Home</a> : Recommend a Link : $linkcat</b><p>\nPlease use the following form to give us details of the link you think should be added to our listings.  Once submitted your link will be validated by a member of site staff before going on display.<p>";
		echo "<form action=links.php method=post><input type=hidden name=action value=reclink><input type=hidden name=cat value=$cat>\n";
		echo "Link Name: <input type=text name=link_name size=30 maxlength=100><p>\n";
		echo "Link Category: <b>$linkcat</b><p>\n";
		echo "Link URL: <input type=text name=link_url size=30 maxlength=255 value=\"http://\"><p>\nLink Description:<br>\n<textarea name=link_desc cols=40 rows=4></textarea><p>";
		echo "Your Name: <input type=text name=link_addname size=30 maxlength=100> *<p>\nYour E-Mail: <input type=text name=link_addemail size=30 maxlength=100> *<p>\n";
		echo "<span class=small>* - You do not have to enter these details but if you do you will recieve an e-mail informing you whether or not your link has been accepted for inclusion in these listings.  Your e-mail address will not be used for any other purpose.</span><p>";
		echo "<input type=submit name=submit value=\"Recommend Link\"></form><p>";
		echo html_footer();
		exit;
	}
	// data has been submitted - check it and add to the database
	
	if ((!$link_name) || ($link_url == "http://") || (!$link_desc))
	{
		echo html_header("$sitename - Error");
		echo "<b><a href=\"links.php\">Links Home</a> : Recommend a Link : Error</b><p>\n";
		echo "You did not fill in all of the required fields.  Hit 'back' and try again.<p>\n";
		echo html_footer();
		exit;
	}
	if (!ereg("^(.+)@(.+)\\.(.+)$", $link_addemail))
		$link_addemail = "none";
	ereg_replace("[^0-9 A-Za-z]", "", $link_addname);
	if ($link_addname == "")
		$link_addname = "none";
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$time = time();
	$sql = "INSERT INTO sslinks SET
		link_name = '$link_name',
		link_cat = '$cat',
		link_url = '$link_url',
		link_desc = '$link_desc',
		link_numvotes = '0',
		link_totalrate = '0',
		link_dateadd = '$time',
		link_validated = 'no',
		link_addname = '$link_addname',
		link_addemail = '$link_addemail',
		link_recommended = 'no'";
	$result = mysql_query($sql);
	if (!$result)
	{
		die("SQL result failed - link was not added");
	}
	else
	{
		echo html_header("Thank You");
		echo "<b><a href=\"links.php\">Links Home</a> : Recommend a Link : Thank You</b>\n";
		echo "Your link is now awaiting validation by a member of staff.<p><a href=\"links.php\">Back to Links Index</a><p>";
		echo html_footer();
		exit;
	}
}

function delete_link($id)
{
	// after confirmation, deletes specified link
	
	global $db_host, $db_name, $db_user, $db_pass, $admin, $submit;
	
	if (!$admin)
	{
		header("Location: admin.php?action=logout");
		exit;
	}
	
	if (!ereg("^[0-9]+$", $id))
	{
		// function has been fed an invalid link id
		header("Location: links.php");
		exit;
	}
	if (!$submit)
	{
		// display form requesting confirmation
		// get link details
		
		$cnx = mysql_connect($db_host, $db_user, $db_pass)
			or die("Unable to connect to database server.");
		mysql_select_db($db_name, $cnx)
			or die("Unable to select database.");
		$result = mysql_query("SELECT * FROM sslinks WHERE link_id = '$id'");
		if (!$result)
			die("SQL result failed");
		while ($row = mysql_fetch_array($result))
		{
			$lid = $row["link_id"];
			$name = $row["link_name"];
			$hits = $row["link_hits"];
			$desc = $row["link_desc"];
			$url = $row["link_url"];
			$totalrate = $row["link_totalrate"];
			$numvotes = $row["link_numvotes"];
			$dateadd = $row["link_dateadd"];
			if ($numvotes > 0)
			{
				$avgrate = sprintf ("%.2f", ($totalrate / $numvotes));
			}
			else
			{
				$avgrate = 0;
			}
		}
		echo html_header("Confirm Deletion");
		echo "<b><a href=\"links.php\">Links Home</a> : Confirm Link Deletion</b><p>\n";
		echo "Please confirm you wish to delete the following link:<p>\n";
		echo "<a href=\"links.php?go=$lid\" target=\"_blank\">$name</a> <span class=small>[$hits hits, $numvotes votes, Average Rating $avgrate]</span><br>\n$desc<br>URL: $url<p>\n";
		echo "<form action=links.php method=post><input type=hidden name=action value=dellink><input type=hidden name=id value=$lid>";
		echo "<input type=submit name=submit value=\"Delete Link\"><p>\n";
		echo html_footer();
		exit;
	}
	
	// delete the link
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$result = mysql_query("DELETE FROM sslinks WHERE link_id = '$id'");
	if (!$result)
		die("SQL result failed");
	echo html_header("Link Deleted");
	echo "<b><a href=\"links.php\">Links Home</a> : Link Deleted</b><p>\n"; 
	echo "The link has been deleted.<p>\n";
	echo html_footer();
	exit;
}

function reject_link($id)
{
	// This is an exact copy of the code for deletion (bad to use copy and paste I know)
	// only this code also e-mails the owner of the link to say it has been deleted.
	// The sole purpose of this function is for deleting links that are under validation.
	
	global $db_host, $db_name, $db_user, $db_pass, $admin, $submit, $sitename, $sitemail;
	
	if (!$admin)
	{
		header("Location: admin.php?action=logout");
		exit;
	}
	
	if (!ereg("^[0-9]+$", $id))
	{
		// function has been fed an invalid link id
		header("Location: links.php");
		exit;
	}
	if (!$submit)
	{
		// display form requesting confirmation
		// get link details
		
		$cnx = mysql_connect($db_host, $db_user, $db_pass)
			or die("Unable to connect to database server.");
		mysql_select_db($db_name, $cnx)
			or die("Unable to select database.");
		$result = mysql_query("SELECT * FROM sslinks WHERE link_id = '$id'");
		if (!$result)
			die("SQL result failed");
		while ($row = mysql_fetch_array($result))
		{
			$lid = $row["link_id"];
			$name = $row["link_name"];
			$hits = $row["link_hits"];
			$desc = $row["link_desc"];
			$url = $row["link_url"];
			$totalrate = $row["link_totalrate"];
			$numvotes = $row["link_numvotes"];
			$dateadd = $row["link_dateadd"];
			$link_addemail = $row["link_addemail"];
			$link_addname = $row["link_addname"];
			if ($numvotes > 0)
			{
				$avgrate = sprintf ("%.2f", ($totalrate / $numvotes));
			}
			else
			{
				$avgrate = 0;
			}
		}
		echo html_header("Confirm Deletion");
		echo "<b><a href=\"links.php\">Links Home</a> : Confirm Link Rejection</b><p>\n";
		echo "Please confirm you wish to delete the following link:<p>\n";
		echo "<a href=\"links.php?go=$lid\" target=\"_blank\">$name</a> <span class=small>[$hits hits, $numvotes votes, Average Rating $avgrate]</span><br>\n$desc<br>URL: $url<br>\n";
		if ($link_addemail != "")
		{
			if ($link_addname == "")
				$link_addname = "Anonymous";
			echo "Submitted by <a href=\"mailto:$link_addemail\">$link_addname</a><p>\n";
		} else 
		{
			echo "<br>\n";
		}
		echo "<form action=links.php method=post><input type=hidden name=action value=dellink><input type=hidden name=id value=$lid>";
		echo "<input type=submit name=submit value=\"Delete Link\"><p>\n";
		echo html_footer();
		exit;
	}
	
	// delete the link
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");

	$result = mysql_query("SELECT * FROM sslinks WHERE link_id = '$id'");
	if (!$result)
		die("SQL result failed");
	while ($row = mysql_fetch_array($result))
	{
		$name = $row["link_name"];
		$url = $row["link_url"];
		$link_addemail = $row["link_addemail"];
		$link_addname = $row["link_addname"];
	}
	if ($link_addemail != "")
	{
		// send mail to punter telling them link has been rejected
		if (($link_addname == "") || ($link_addname == "none"))
			$link_addname = "Visitor";
		$mail = "Dear $link_addname,\n\n";
		$mail .= "Unfortunately the link you submitted to $sitename for inclusion in\n";
		$mail .= "our links database has been rejected.\n\n";
		$mail .= "Name: $name\n";
		$mail .= "URL: $url\n\n";
		$mail .= "Your link has been deleted, and we have wiped the record of your \n";
		$mail .= "e-mail address from our system.  This is a one off mailing to keep \n";
		$mail .= "you informed of the progress of you link - you will not be contacted \n";
		$mail .= "again.\n";
		$yay = @mail($link_addemail, "$sitename - Your link has been rejected", $mail, "From: $sitemail\n");
	}
	$result2 = mysql_query("DELETE FROM sslinks WHERE link_id = '$id'");
	if (!$result2)
		die("SQL result failed");
	echo html_header("Link Deleted");
	echo "<b><a href=\"links.php\">Links Home</a> : Link Rejected</b><p>\n";
	echo "The link has been deleted.<p>\n";
	if ($yay)
		echo "An e-mail was dispatched to $link_addemail informing them that their link was rejected.<p>\n";
	echo html_footer();
	exit;
}

function edit_link($id)
{
	// displays form for editing link, or applys changes if form is submitted
	
	global $db_host, $db_name, $db_user, $db_pass, $link_name, $link_cat, $link_desc, $link_url, $link_recommended, $link_validated, $submit, $admin;

	if (!$admin)	
	{
		header("Location: links.php?action=logout");
		exit;
	}
	if (ereg("[^0-9]", $id))
	{
		// function has been fed an invalid link id
		header("Location: links.php");
		exit;
	}
	if (!$submit)
	{
		// show form for editing link
		$cnx = mysql_connect($db_host, $db_user, $db_pass)
			or die("Unable to connect to database server.");
		mysql_select_db($db_name, $cnx)
			or die("Unable to select database.");
		$result = mysql_query("SELECT * FROM sslinks WHERE link_id = '$id'");
		if (!$result)
			die("SQL result failed");
		while ($row = mysql_fetch_array($result))
		{
			$lid = $row["link_id"];
			$name = $row["link_name"];
			$desc = $row["link_desc"];
			$url = $row["link_url"];
			$cat = $row["link_cat"];
			$rec = $row["link_recommended"];
			$val = $row["link_validated"];
		}
		echo html_header("Edit Link: $name");
		echo "<b><a href=\"links.php\">Links Home</a> : Edit Link : $name</b><p>\n";
		echo "<form action=links.php method=post><input type=hidden name=action value=editlink><input type=hidden name=id value=$lid>\n";
		echo "Link Name: <input type=text name=link_name size=30 value=\"$name\" maxlength=100><p>\nLink URL: <input type=text name=link_url size=30 maxlength=255 value=\"$url\"><p>\n";
		echo "Link Description:<br>\n<textarea name=link_desc cols=40 rows=4>$desc</textarea><p>\n";
		echo "Link Category ID: <input type=text name=link_cat size=5 value=\"$cat\"> - 0 is the front page, any other number is one of the sub category pages.<p>\n";
		
		// build select boxes for validated and recommended
		
		if ($rec == "yes")
		{
			$rec1 = " SELECTED";
			$rec2 = "";
		}
		else
		{
			$rec1 = "";
			$rec2 = " SELECTED";
		}
		echo "Recommended? <select name=link_recommended size=1>\n<option$rec1>yes\n<option$rec2>no\n</select><p>\n";
		if ($val == "yes")
		{
			$val1 = " SELECTED";
			$val2 = "";
		}
		else
		{
			$val1 = "";
			$val2 = " SELECTED";
		}
		echo "Validated? <select name=link_validated size=1>\n<option$val1>yes\n<option$val2>no\n</select><p>\n";
		echo "<input type=submit name=submit value=\"Edit Link\"><p>\n";
		echo html_footer();
		exit;
	}
	
	// Form has been submitted - update the database entry
	
	$sql = "UPDATE sslinks SET
		link_name = '$link_name',
		link_url = '$link_url',
		link_desc = '$link_desc',
		link_cat = '$link_cat',
		link_validated = '$link_validated',
		link_recommended = '$link_recommended'
		WHERE link_id = '$id'";
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$result = mysql_query($sql);
	if (!$result)
		die("SQL result failed");
	header("Location: links.php?cat=$link_cat");
	exit;
}

function validate_list()
{
	// lists all non-validated links
		global $db_host, $db_name, $db_user, $db_pass, $admin;
	
	if (!$admin)	
	{
		header("Location: links.php?action=logout");
		exit;
	}
	
	// Returns HTML for displaying list of links attached to category where id = $id
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$result = mysql_query("SELECT * FROM sslinks WHERE link_validated = 'no' ORDER BY link_name");
	if (!$result)
		die("SQL result failed");
	$html = "";
	$num = mysql_num_rows($result);
	while ($row = mysql_fetch_array($result))
	{
		$lid = $row["link_id"];
		$name = $row["link_name"];
		$hits = $row["link_hits"];
		$desc = $row["link_desc"];
		$cat = $row["link_cat"];
		$totalrate = $row["link_totalrate"];
		$numvotes = $row["link_numvotes"];
		$dateadd = $row["link_dateadd"];
		$dateadd = date ("jS M Y", $dateadd);
		if ($numvotes > 0)
		{
			$avgrate = sprintf ("%.2f", ($totalrate / $numvotes));
		}
		else
		{
			$avgrate = 0;
		}
		
		$catname = get_catname($cat);
		
		$rateme = "<input type=hidden name=action value=rate><input type=hidden name=id value=$lid>";
		$rateme .= "<select name=score size=1 class=small onchange=\"document.rate$lid.submit()\">";
		$rateme .= "<option>-";
		$rateme .= "<option>1";
		$rateme .= "<option>2";
		$rateme .= "<option>3";
		$rateme .= "<option>4";
		$rateme .= "<option>5";
		$rateme .= "<option>6";
		$rateme .= "<option>7";
		$rateme .= "<option>8";
		$rateme .= "<option>9";
		$rateme .= "<option>10";
		$rateme .= "</select>";
		$html .= "<form action=links.php method=post name=rate$lid><td class=standard><a href=\"links.php?go=$lid\" target=\"_blank\">$name</a> <span class=small>[$hits hits, $numvotes votes, Average Rating $avgrate]</span>";
		$html .= " - <a href=\"links.php?action=editlink&id=$lid\">Edit Link</a> | <a href=\"links.php?action=reject_link&id=$lid\">Delete Link</a> | <a href=\"links.php?action=vallink&id=$lid\">Validate Link</a>";
		$html .= "<br>\n$desc <span class=small>RATE THIS: </span>$rateme<br>Category: <a href=\"links.php?cat=$cat\">$catname</a> Added: $dateadd</td></form><tr>\n";
	}
	$html = "<table border=0 cellpadding=1 cellspacing=1 width=100%>\n" . $html;
	$html .= "</table><p>\n";

	echo html_header("Validate Links");
	echo "<b><a href=\"links.php\">Links Home</a> : Validate Links</b><p>\n";
	if ($num == 0)
	{
		echo "There are no links awaiting validation.<p>\n";
	}
	else
	{	echo "The following links are awaiting validation:<p>\n";
		echo $html;
	}
	echo html_footer();
	exit;
}

function val_link($id)
{
	// validates (sets link_validated to 'yes') the specified link
	global $admin, $db_name, $db_host, $db_pass, $db_user;
	
	if (ereg("[^0-9]", $id))
	{
		// function has been fed an invalid link id
		header("Location: links.php");
		exit;
	}
	if (!$admin)
	{
		header("Location: links.php?action=logout");
		exit;
	}
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");

	$result = mysql_query("SELECT * FROM sslinks WHERE link_id = '$id'");
	if (!$result)
		die("SQL result failed");
	while ($row = mysql_fetch_array($result))
	{
		$name = $row["link_name"];
		$url = $row["link_url"];
		$link_addemail = $row["link_addemail"];
		$link_addname = $row["link_addname"];
	}
	$time = time();
	$result2 = mysql_query("UPDATE sslinks SET link_validated = 'yes', link_dateadd = '$time' WHERE link_id = '$id'");
	if (!$result2)
		die("SQL result failed");
	if ($link_addemail != "")
	{
		// send mail to punter telling them link has been rejected
		if (($link_addname == "") || ($link_addname == "none"))
			$link_addname = "Visitor";
		$mail = "Dear $link_addname,\n\n";
		$mail .= "The link you submitted to $sitename for inclusion in our links \n";
		$mail .= "database has been validated, and is now on display on the site.\n\n";
		$mail .= "Name: $name\n";
		$mail .= "URL: $url\n\n";
		$mail .= "This is a one off mailing to keep you informed of the progress \n";
		$mail .= "of you link - you will not be contacted again.\n";
		$yay = @mail($link_addemail, "$sitename - Your link has been validated", $mail, "From: $sitemail\n");
	}
	if ($yay)
	{
		echo html_header("E-Mail Sent");
		echo "<b><a href=\"links.php\">Links Home</a> : Link Validated</b><p>\n";
		echo "An e-mail has been sent to $link_addemail informing them that their link has been validated.<p>\n";
		echo "<a href=\"links.php?action=validated\">Back to Validation List</a><p>\n";
		echo html_footer();
		exit;
	}
	header("Location: links.php?action=validated");
	exit;
}

function search_results($search)
{
	$searchtext = htmlentities($search);
	$search = stripslashes($search);
	$links_sql = "SELECT * FROM sslinks WHERE link_validated = 'yes' AND
		(link_name LIKE '%$search%' OR link_desc LIKE '%$search%')
		ORDER BY link_name";
	$cats_sql = "SELECT lcat_id, lcat_name, lcat_ranking FROM sslinkcats WHERE
		(lcat_name LIKE '%$search%' OR lcat_header LIKE '%$search%')
		ORDER BY lcat_ranking DESC, lcat_name";
	$links = links_sql($links_sql);
	
	echo html_header("Search Results");
	echo "<b><a href=\"links.php\">Links Home</a> : Search Links</b><p>\nYour search for <i>$searchtext</i> resulted in the following matches:<p>\n";
	
	echo cats_sql($cats_sql);
	
	if (!$links)
	{
		echo "No links were found.<p>";
	}
	else
	{
		echo $links;
	}
	echo "<form action=links.php method=get>Search Again: <input type=text size=20 name=search> <input type=submit value=Search></form>";
	
	echo html_footer();
	exit;
}

function show_searchpage()
{
	// displays search form
	echo html_header("Search");
	echo "<b><a href=\"links.php\">Links Home</a> : Search Links</b><p>\n";
	echo "<form action=links.php method=get>";
	echo "<input type=text size=20 name=search><p>\n";
	echo "<input type=submit value=Search></form><p>";
	echo html_footer();
	exit;
}

function new_links($numdays)
{
	global $nol;
	// displays a list of links added in the last x days - limit is $nol links
	if (!$numdays)
		$numdays = 5;
	$time = time();
	$mintime = $time - ($numdays * 24 * 60 * 60);
	$links_sql = "SELECT * FROM sslinks WHERE link_dateadd > $mintime AND link_validated = 'yes' ORDER BY link_dateadd DESC LIMIT 0,$nol";
	$links = links_sql($links_sql);
	
	echo html_header("New Links");
	echo "<b><a href=\"links.php\">Links Home</a> : New Links</b><p>\nDisplaying links added in the last $numdays days.  A maximum of $nol links will be displayed.<p>\n";
	
	if (!$links)
	{
		echo "No links were found.<p>";
	}
	else
	{
		echo $links;
	}
	echo "<p><form action=links.php method=get>Show links added in the last <input type=text name=days value=\"$numdays\" size=3> days. <input type=hidden name=action value=newlinks><input type=submit value=Go></form><p>";
	
	echo html_footer();
	exit;
}

function popular_links()
{
	global $nol;
	// displays 20 links with the most hits
	$links_sql = "SELECT * FROM sslinks WHERE link_validated = 'yes' AND link_hits > 0 ORDER BY link_hits DESC LIMIT 0,$nol";
	$links = links_sql($links_sql);
	
	echo html_header("Popular Links");
	echo "<b><a href=\"links.php\">Links Home</a> : Popular Links</b><p>\nDisplaying top $nol links by number of hits.<p>\n";
	
	if (!$links)
	{
		echo "No links were found with more than 0 hits.<p>";
	}
	else
	{
		echo $links;
	}
	echo "<p>\n";
	
	echo html_footer();
	exit;
}

function top_rated()
{
	// displays 20 links with the highest ratings (must have min. $minvotes votes)
	global $minvotes, $nol;
	$links_sql = "SELECT * FROM sslinks WHERE link_validated = 'yes' AND link_numvotes > $minvotes ORDER BY (link_totalrate / link_numvotes) DESC LIMIT 0,$nol";
	$links = links_sql($links_sql);
	
	echo html_header("Top Rated Links");
	echo "<b><a href=\"links.php\">Links Home</a> : Top Rated Links</b><p>\nDisplaying top $nol links by rating (only links with more than $minvotes votes are counted).<p>\n";
	
	if (!$links)
	{
		echo "No links were found with more than $minvotes votes.<p>";
	}
	else
	{
		echo $links;
	}
	echo "<p>\n";
	
	echo html_footer();
	exit;
}

function edit_cat($id)
{
	// edit specified category
	global $db_host, $db_name, $db_user, $db_pass, $lcat_name, $lcat_cat, $lcat_header, $lcat_rank, $submit, $admin;
	if (!$admin)	
	{
		header("Location: links.php?action=logout");
		exit;
	}
	if (ereg("[^0-9]", $id))
	{
		// function has been fed an invalid link id
		header("Location: links.php");
		exit;
	}
	if (!$submit)
	{
		// show form for editing link
		$cnx = mysql_connect($db_host, $db_user, $db_pass)
			or die("Unable to connect to database server.");
		mysql_select_db($db_name, $cnx)
			or die("Unable to select database.");
		$result = mysql_query("SELECT * FROM sslinkcats WHERE lcat_id = '$id'");
		if (!$result)
			die("SQL result failed");
		while ($row = mysql_fetch_array($result))
		{
			$cid = $row["lcat_id"];
			$name = $row["lcat_name"];
			$cat = $row["lcat_cat"];
			$header = $row["lcat_header"];
			$ranking = $row["lcat_ranking"];
		}
		echo html_header("Edit Category: $name");
		echo "<b>Edit Category: $name</b><p>\n";
		echo "<form action=links.php method=post><input type=hidden name=action value=editcat><input type=hidden name=id value=$cid>\n";
		echo "Category Name: <input type=text name=lcat_name size=30 value=\"$name\" maxlength=100><p>\nCategory Ranking: <input type=text name=lcat_rank size=5 maxlength=11 value=\"$ranking\"> - Used for controlling the order categories are displayed.<p>\n";
		echo "Category Header:<br>\n<textarea name=lcat_header cols=40 rows=4>$header</textarea><p>\n";
		echo "Nested Category ID: <input type=text name=lcat_cat size=5 value=\"$cat\"> - 0 is the front page, any other number is one of the sub category pages.<p>\n";
		
		echo "<input type=submit name=submit value=\"Edit Category\"><p>\n";
		echo html_footer();
		exit;
	}
	
	// Form has been submitted - update the database entry
	
	$sql = "UPDATE sslinkcats SET
		lcat_name = '$lcat_name',
		lcat_ranking = '$lcat_rank',
		lcat_header = '$lcat_header',
		lcat_cat = '$lcat_cat'
		WHERE lcat_id = '$id'";
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$result = mysql_query($sql);
	if (!$result)
		die("SQL result failed. \$sql was $sql");
	header("Location: links.php?cat=$link_cat");
	exit;
}

function numlinks_array()
{
	global $db_name, $db_host, $db_user, $db_pass;
	// returns an array of the number of links in each category
	$sql = "SELECT sslinkcats.lcat_id, COUNT(*) AS NumLinks 
		FROM sslinks, sslinkcats 
		WHERE link_cat = sslinkcats.lcat_id 
		GROUP BY link_cat";
	$cnx = mysql_connect($db_host, $db_user, $db_pass)
		or die("Unable to connect to database server.");
	mysql_select_db($db_name, $cnx)
		or die("Unable to select database.");
	$result = mysql_query($sql);
	if (!$result)
		die("Database error while getting array of number of links in categories.");
	$numlinks[] = "";
	while ($row = mysql_fetch_array($result))
	{
		$lcat_id = $row["lcat_id"];
		$numlinks[$lcat_id] = $row["NumLinks"];
	}
	return $numlinks;
}

?>